﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.IO;
using System.Collections;

namespace acmesoft.web.ascx
{
    public partial class AbstractGoals : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Hashtable SmartPlanUser = (Hashtable)Session.Contents["SMART_PLAN_USER"];
            Hashtable RoleStages = (Hashtable)Session.Contents["ROLE_STAGES"];
            string roleId = "";

            if (Session.Contents["ACTIVE_ORGANIZATION_ID"] != null)
                roleId = SmartPlanUser[Session.Contents["ACTIVE_ORGANIZATION_ID"].ToString()].ToString();
            else
                roleId = SmartPlanUser[Session.Contents["DEFAULT_ORGANIZATION_ID"].ToString()].ToString();
            int roleStage = int.Parse(RoleStages[roleId].ToString());

            if (roleStage == 0) //BlockedUsers
            {
                gridAbstractGoals.Visible = false;
                Label1.Text = "Sorry, you are blocked by administrators.";
            }
            else if (roleStage < 4) //ReadOnly
            {
                gridAbstractGoals.Columns[7].AllowDelete = false;
                gridAbstractGoals.Columns[7].AllowEdit = false;
                gridAbstractGoals.AllowAddingRecords = false;
            }
            else if (roleStage == 4) //IUser
            {
                gridAbstractGoals.Columns[7].AllowDelete = false;
                gridAbstractGoals.Columns[7].AllowEdit = false;
                gridAbstractGoals.AllowAddingRecords = true;
            }
            else if (roleStage == 5) //UpdateUsers
            {
                gridAbstractGoals.Columns[7].AllowDelete = false;
                gridAbstractGoals.Columns[7].AllowEdit = true;
                gridAbstractGoals.AllowAddingRecords = false;
            }
            else if (roleStage == 7 || roleStage == 6) //ModifyUsers & InsertUsers
            {
                gridAbstractGoals.Columns[7].AllowDelete = false;
                gridAbstractGoals.Columns[7].AllowEdit = true;
                gridAbstractGoals.AllowAddingRecords = true;
            }
            else if (roleStage == 8) //Administrators
            {
                gridAbstractGoals.Columns[7].AllowDelete = true;
                gridAbstractGoals.Columns[7].AllowEdit = true;
                gridAbstractGoals.AllowAddingRecords = true;
            }
            else if (roleStage < 8) //++Administrator
            {
                gridAbstractGoals.Columns[7].AllowDelete = true;
                gridAbstractGoals.Columns[7].AllowEdit = true;
                gridAbstractGoals.AllowAddingRecords = true;
            }

        }

        protected void gridAbstractGoals_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSource1.ConnectionString);

            try
            {
                myConn.Open();
                SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblAbstractGoals(organizationId, userId, name, code, exp, prerequisites) VALUES (@organizationId, @userId, @name, @code, @exp, @prerequisites)", myConn);

                myComm.Parameters.Add("@organizationId", SqlDbType.VarChar).Value = e.Record["OrgName"];
                myComm.Parameters.Add("@userId", SqlDbType.VarChar).Value = Session.Contents["USER_ID"];
                myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
                myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
                myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
                myComm.Parameters.Add("@prerequisites", SqlDbType.VarChar).Value = e.Record["prerequisites"];

                myComm.ExecuteNonQuery();

                DataSet ds = new DataSet();
                SqlDataAdapter adp = new SqlDataAdapter(("SELECT id FROM AcmeSoft.tblAbstractGoals WHERE name = '" + e.Record["name"] + "'"), myConn);
                adp.Fill(ds);
                Directory.CreateDirectory(Server.MapPath("/Organizations/") + e.Record["OrgName"] + "/" + ds.Tables[0].Rows[0].ItemArray[0].ToString());

                myConn.Close();
            }
            catch (Exception ex)
            {
                Label1.Text = ex.Message;
            }
        }

        protected void gridAbstractGoals_UpdateCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSource1.ConnectionString);
            DataSet ds = new DataSet();

            try
            {
                myConn.Open();
                SqlDataAdapter adp = new SqlDataAdapter(("SELECT organizationId FROM AcmeSoft.tblAbstractGoals WHERE id = '" + e.Record["id"] + "'"), myConn);
                adp.Fill(ds);

                SqlCommand myComm = new SqlCommand("UPDATE AcmeSoft.tblAbstractGoals SET organizationId = @OrgName, userId = @UserName, name = @name, code = @code, exp = @exp, prerequisites = @prerequisites WHERE id = @id", myConn);
                myComm.Parameters.Add("@OrgName", SqlDbType.VarChar).Value = e.Record["OrgName"];
                myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = Session.Contents["USER_ID"];
                myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
                myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
                myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
                myComm.Parameters.Add("@prerequisites", SqlDbType.VarChar).Value = e.Record["prerequisites"];
                myComm.Parameters.Add("@id", SqlDbType.VarChar).Value = e.Record["id"];

                myComm.ExecuteNonQuery();
                myConn.Close();

                string sourceDir = Server.MapPath("/Organizations" + "\\"
                    + ds.Tables[0].Rows[0].ItemArray[0].ToString() + "\\"
                    + e.Record["id"]);
                string destDir = Server.MapPath("/Organizations" + "\\"
                    + e.Record["OrgName"] + "\\"
                    + e.Record["id"]);
                if (sourceDir != destDir)
                    Directory.Move(sourceDir, destDir);
                gridAbstractGoals.DataBind();
            }
            catch (Exception ex)
            {
                Label1.Text = ex.Message;
            }
        }

        protected void gridAbstractGoals_DeleteCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSource1.ConnectionString); 

            try
            {
                myConn.Open();
                SqlCommand myComm = new SqlCommand("DELETE FROM AcmeSoft.tblAbstractGoals WHERE (id = @id)", myConn);

                myComm.Parameters.Add("@id", SqlDbType.VarChar).Value = e.Record["id"];

                myComm.ExecuteNonQuery();
                myConn.Close();
            }
            catch (Exception ex)
            {
                if(ex.Message.Contains("REFERENCE"))
                    Label1.Text = "You can not delete Abstract Goal that has Course(s) reference.";
                UpdatePanel1.Update();
            }
        }
    }
}