﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.IO;
using System.Collections;

namespace acmesoft.web.ascx
{
    public partial class CourseObjectives : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Hashtable SmartPlanUser = (Hashtable)Session.Contents["SMART_PLAN_USER"];
            Hashtable RoleStages = (Hashtable)Session.Contents["ROLE_STAGES"];
            string roleId = "";

            if (Session.Contents["ACTIVE_ORGANIZATION_ID"] != null)
                roleId = SmartPlanUser[Session.Contents["ACTIVE_ORGANIZATION_ID"].ToString()].ToString();
            else
                roleId = SmartPlanUser[Session.Contents["DEFAULT_ORGANIZATION_ID"].ToString()].ToString();
            int roleStage = int.Parse(RoleStages[roleId].ToString());

            if (roleStage == 0) //BlockedUsers
            {
                gridCourseObjectives.Visible = false;
                Label1.Text = "Sorry, you are blocked by administrators.";
            }
            else if (roleStage < 4) //ReadOnly
            {
                gridCourseObjectives.Columns[7].AllowDelete = false;
                gridCourseObjectives.Columns[7].AllowEdit = false;
                gridCourseObjectives.AllowAddingRecords = false;
            }
            else if (roleStage == 4) //IUser
            {
                gridCourseObjectives.Columns[7].AllowDelete = false;
                gridCourseObjectives.Columns[7].AllowEdit = false;
                gridCourseObjectives.AllowAddingRecords = true;
            }
            else if (roleStage == 5) //UpdateUsers
            {
                gridCourseObjectives.Columns[7].AllowDelete = false;
                gridCourseObjectives.Columns[7].AllowEdit = true;
                gridCourseObjectives.AllowAddingRecords = false;
            }
            else if (roleStage == 7 || roleStage == 6) //ModifyUsers & InsertUsers
            {
                gridCourseObjectives.Columns[7].AllowDelete = false;
                gridCourseObjectives.Columns[7].AllowEdit = true;
                gridCourseObjectives.AllowAddingRecords = true;
            }
            else if (roleStage == 8) //Administrators
            {
                gridCourseObjectives.Columns[7].AllowDelete = true;
                gridCourseObjectives.Columns[7].AllowEdit = true;
                gridCourseObjectives.AllowAddingRecords = true;
            }
            else if (roleStage < 8) //++Administrator
            {
                gridCourseObjectives.Columns[7].AllowDelete = true;
                gridCourseObjectives.Columns[7].AllowEdit = true;
                gridCourseObjectives.AllowAddingRecords = true;
            }

        }
        protected void grid1_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSourceCourseObjectives.ConnectionString);
            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblCourseObjectives(goalId, userId, name, code, exp, viewOrder)"
                + " VALUES (@GoalName, @UserName, @name, @code, @exp, @viewOrder)", myConn);

            DataSet ds = new DataSet();
            SqlDataAdapter adp = new SqlDataAdapter(("SELECT AcmeSoft.tblAbstractGoals.organizationId, AcmeSoft.tblCourseObjectives.id "
                + "FROM AcmeSoft.tblAbstractGoals INNER JOIN AcmeSoft.tblCourseObjectives ON AcmeSoft.tblAbstractGoals.id = AcmeSoft.tblCourseObjectives.goalId "
                + "WHERE (AcmeSoft.tblAbstractGoals.id = '" + e.Record["GoalName"]
                + "' AND AcmeSoft.tblCourseObjectives.name = '" + e.Record["name"].ToString() + "')"), myConn);

            try
            {
                myConn.Open();

                myComm.Parameters.Add("@GoalName", SqlDbType.VarChar).Value = e.Record["GoalName"];
                myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = Session.Contents["USER_ID"];
                myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
                myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
                myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
                myComm.Parameters.Add("@viewOrder", SqlDbType.VarChar).Value = e.Record["viewOrder"];
                myComm.ExecuteNonQuery();

                adp.Fill(ds);
                Directory.CreateDirectory(Server.MapPath("/Organizations/")
                    + ds.Tables[0].Rows[0].ItemArray[0].ToString()
                    + "/" + e.Record["GoalName"].ToString()
                    + "/" + ds.Tables[0].Rows[0].ItemArray[1].ToString());

                myConn.Close();
            }
            catch (Exception ex)
            {
                Label1.Text = ex.Message;
            }
        }

        protected void grid1_UpdateCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSourceCourseObjectives.ConnectionString);
            DataSet ds = new DataSet();
            SqlDataAdapter adp = new SqlDataAdapter(("SELECT AcmeSoft.tblAbstractGoals.organizationId, AcmeSoft.tblCourseObjectives.goalId, AcmeSoft.tblAbstractGoals.id "
                + "FROM AcmeSoft.tblCourseObjectives INNER JOIN AcmeSoft.tblAbstractGoals ON AcmeSoft.tblCourseObjectives.goalId = AcmeSoft.tblAbstractGoals.id"
                + " WHERE AcmeSoft.tblCourseObjectives.id = '" + e.Record["id"] + "'"), myConn);
            SqlCommand myComm = new SqlCommand("UPDATE AcmeSoft.tblCourseObjectives SET goalId = @GoalName, userId = @UserName, name = @name, viewOrder = @viewOrder, code = @code, exp = @exp" 
                + " WHERE id = @id", myConn);

            try
            {

                myConn.Open();
                adp.Fill(ds);

                myComm.Parameters.Add("@GoalName", SqlDbType.VarChar).Value = e.Record["GoalName"];
                myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = Session.Contents["USER_ID"];
                myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
                myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
                myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
                myComm.Parameters.Add("@viewOrder", SqlDbType.VarChar).Value = e.Record["viewOrder"];
                myComm.Parameters.Add("@id", SqlDbType.VarChar).Value = e.Record["id"];

                myComm.ExecuteNonQuery();
                myConn.Close();
                string sourcePath = Server.MapPath("/Organizations") + "\\"
                    + ds.Tables[0].Rows[0].ItemArray[0].ToString() + "\\"
                    + ds.Tables[0].Rows[0].ItemArray[1].ToString() + "\\"
                    + e.Record["id"];
                string destPath = Server.MapPath("/Organizations") + "\\"
                    + ds.Tables[0].Rows[0].ItemArray[0].ToString() + "\\"
                    + e.Record["GoalName"] + "\\"
                    + e.Record["id"];
                if (sourcePath != destPath)
                    Directory.Move(sourcePath, destPath);
            }
            catch (Exception ex)
            {
                Label1.Text = ex.Message;
            }

            gridCourseObjectives.DataBind();
        }
    }
}