﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.Text.RegularExpressions;
using System.Collections;

namespace acmesoft.web.ascx
{
    public partial class CourseTopics : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Hashtable SmartPlanUser = (Hashtable)Session.Contents["SMART_PLAN_USER"];
            Hashtable RoleStages = (Hashtable)Session.Contents["ROLE_STAGES"];
            string roleId = "";

            if (Session.Contents["ACTIVE_ORGANIZATION_ID"] != null)
                roleId = SmartPlanUser[Session.Contents["ACTIVE_ORGANIZATION_ID"].ToString()].ToString();
            else
                roleId = SmartPlanUser[Session.Contents["DEFAULT_ORGANIZATION_ID"].ToString()].ToString();
            int roleStage = int.Parse(RoleStages[roleId].ToString());

            if (roleStage == 0) //BlockedUsers
            {
                grid1.Visible = false;
                Label1.Text = "Sorry, you are blocked by administrators.";
            }
            else if (roleStage < 4) //ReadOnly
            {
                grid1.Columns[10].AllowDelete = false;
                grid1.Columns[10].AllowEdit = false;
                grid1.AllowAddingRecords = false;
            }
            else if (roleStage == 4) //IUser
            {
                grid1.Columns[10].AllowDelete = false;
                grid1.Columns[10].AllowEdit = false;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage == 5) //UpdateUsers
            {
                grid1.Columns[10].AllowDelete = false;
                grid1.Columns[10].AllowEdit = true;
                grid1.AllowAddingRecords = false;
            }
            else if (roleStage == 7 || roleStage == 6) //ModifyUsers & InsertUsers
            {
                grid1.Columns[10].AllowDelete = false;
                grid1.Columns[10].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage == 8) //Administrators
            {
                grid1.Columns[10].AllowDelete = true;
                grid1.Columns[10].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage < 8) //++Administrator
            {
                grid1.Columns[10].AllowDelete = true;
                grid1.Columns[10].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }

            HttpFileCollection files = Page.Request.Files;
            string filesRoot = "/Organizations/CourseMaterials/";
            string filePath = "";
            string fileName = "";

            for (int i = 0; i < files.Count; i++)
            {
                HttpPostedFile file = files[i];
                if (file.FileName.Length > 0)
                {
                    Regex reg = new Regex(@"((?:[^\\]*\\)*)(\S+)", RegexOptions.Compiled);
                    fileName = DateTime.Now.Ticks.ToString() + "_" + reg.Replace(file.FileName, "$2");
                    filePath = filesRoot + fileName;

                    file.SaveAs(Server.MapPath(filePath));
                    break;
                }
            }
        }
        protected void grid1_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {

            SqlConnection myConn = new SqlConnection(SqlDataSource1.ConnectionString);
            myConn.Open();
            
            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblCourseTopics(courseId, objectiveId, userId, name, code, durationType, duration, exp, viewOrder)"
                + " VALUES (@CourseName, @ObjName, @UserName, @name, @code, @durationType, @duration, @exp, @viewOrder)", myConn);

            myComm.Parameters.Add("@CourseName", SqlDbType.VarChar).Value = e.Record["CourseName"];
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = Session.Contents["USER_ID"];
            myComm.Parameters.Add("@ObjName", SqlDbType.VarChar).Value = e.Record["ObjName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@durationType", SqlDbType.VarChar).Value = e.Record["durationType"];
            myComm.Parameters.Add("@duration", SqlDbType.VarChar).Value = e.Record["duration"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@viewOrder", SqlDbType.VarChar).Value = e.Record["viewOrder"];

            myComm.ExecuteNonQuery();
            myConn.Close();
        }
    }
}