﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Courses.ascx.cs" Inherits="acmesoft.web.ascx.Courses" %>
<%@ Register Assembly="obout_Grid_NET" Namespace="Obout.Grid" TagPrefix="cc1" %>
<%@ Register TagPrefix="cc1" Namespace="Obout.Interface" Assembly="obout_Interface" %>

<script language="javascript" type="text/javascript">
    function OnBeforeDelete(record) {
        if (confirm("Are you sure you want to delete the Course with the name [" + record.name + "]?") == false) {
            return false;
        }
        return true;
    }
</script>

<cc1:Grid ID="gridCourses" runat="server" AutoGenerateColumns="False" FolderStyle="~/elements/style/premiere_blue"
    RowEditTemplateId="tplRowEdit" DataSourceID="SqlDataSourceCourses" AllowGrouping="true" Serialize="true"
    GroupBy="state" HideColumnsWhenGrouping="false" OnInsertCommand="grid1_InsertCommand"
    Width="100%" AllowFiltering="true" EnableRecordHover="false" AllowRecordSelection="false">
    <ClientSideEvents OnBeforeClientDelete="OnBeforeDelete" />
    <%--<MasterDetailSettings LoadingMode="OnCallback" />
    <DetailGrids>
        <cc1:DetailGrid ID="gridCourseTopics" runat="server" AutoGenerateColumns="False"
            FolderStyle="~/elements/style/premiere_blue" RowEditTemplateId="tplRowEditCourseTopics"
            DataSourceID="SqlDataSourceCourseTopics" OnInsertCommand="gridCourseTopics_InsertCommand"
            Width="100%" ForeignKeys="id">
            <ClientSideEvents OnBeforeClientDelete="OnBeforeDelete" />
            <Columns>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="id" HeaderText="Id" Width="200px"
                    Visible="false">
                    <TemplateSettings RowEditTemplateControlId="txtIdCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="name" HeaderText="Course Topic"
                    Width="230">
                    <TemplateSettings RowEditTemplateControlId="txtNameCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="CourseName" HeaderText="Course Name"
                    Width="200">
                    <TemplateSettings RowEditTemplateControlId="ddlCoursesCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="ObjName" HeaderText="Objective Name"
                    Width="200">
                    <TemplateSettings RowEditTemplateControlId="ddlCourseObjectivesCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="UserName" HeaderText="User Name"
                    Width="120">
                    <TemplateSettings RowEditTemplateControlId="ddlUsersCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="code" HeaderText="Code" Width="150px"
                    Visible="false">
                    <TemplateSettings RowEditTemplateControlId="txtCodeCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="durationType" HeaderText="Duration Type"
                    Width="200px" Visible="false">
                    <TemplateSettings RowEditTemplateControlId="ddlDurationTypeCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="duration" HeaderText="Duration"
                    Width="100px" Visible="false">
                    <TemplateSettings RowEditTemplateControlId="txtDurationCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="exp" HeaderText="Explanation"
                    Width="150px" Visible="false">
                    <TemplateSettings RowEditTemplateControlId="txtExpCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ConvertEmptyStringToNull="False" DataField="viewOrder" HeaderText="View Order"
                    Width="0px" Visible="false">
                    <TemplateSettings RowEditTemplateControlId="txtViewOrderCourseTopics" RowEditTemplateControlPropertyName="value" />
                </cc1:Column>
                <cc1:Column ID="Column3" AllowEdit="true" AllowDelete="true" HeaderText="Edit / Delete"
                    Width="120" />
            </Columns>
            <TemplateSettings RowEditTemplateId="tplRowEditCourseTopics" />
            <Templates>
                <cc1:GridTemplate runat="server" ID="tplRowEditCourseTopics">
                    <Template>
                        <table class="rowEditTable">
                            <tr>
                                <td valign="top">
                                    <fieldset style="width: 510px; height: 213px;">
                                        <legend>Course Information</legend>
                                        <table>
                                            <tr>
                                                <td>
                                                    Course Objective Name:
                                                </td>
                                                <td>
                                                    <cc1:OboutDropDownList runat="server" ID="ddlCourseObjectivesCourseTopics" DataSourceID="SqlDataSourceCourseObjectives"
                                                        DataValueField="id" DataTextField="name" CssClass="ob_gEC" Width="250" Height="50"
                                                        AppendDataBoundItems="true">
                                                        <asp:ListItem Text="Select..." Selected="True"></asp:ListItem>
                                                    </cc1:OboutDropDownList>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    Course Name:
                                                </td>
                                                <td>
                                                    <cc1:OboutDropDownList runat="server" ID="ddlCoursesCourseTopics" DataSourceID="SqlDataSourceCoursesCourseTopics"
                                                        DataValueField="id" DataTextField="name" CssClass="ob_gEC" Width="350" Height="50"
                                                        AppendDataBoundItems="true">
                                                        <asp:ListItem Text="Select..." Selected="True"></asp:ListItem>
                                                    </cc1:OboutDropDownList>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    User Name:
                                                </td>
                                                <td>
                                                    <cc1:OboutDropDownList runat="server" ID="ddlUsersCourseTopics" DataSourceID="SqlDataSourceUsers"
                                                        DataValueField="userId" DataTextField="UserName" CssClass="ob_gEC" Width="250"
                                                        Height="50" AppendDataBoundItems="true">
                                                        <asp:ListItem Text="Select..." Selected="True"></asp:ListItem>
                                                    </cc1:OboutDropDownList>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    Name:
                                                </td>
                                                <td>
                                                    <cc1:OboutTextBox runat="server" ID="txtNameCourseTopics" Width="250" />
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    Code:
                                                </td>
                                                <td>
                                                    <cc1:OboutTextBox runat="server" ID="txtCodeCourseTopics" Width="250" />
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    Duration:
                                                </td>
                                                <td>
                                                    <cc1:OboutTextBox runat="server" ID="txtDurationCourseTopics" Width="50" />
                                                    <cc1:OboutDropDownList runat="server" ID="ddlDurationTypeCourseTopics" CssClass="ob_gEC"
                                                        Width="100" Height="52">
                                                        <asp:ListItem Value="1">day</asp:ListItem>
                                                        <asp:ListItem Value="7">week</asp:ListItem>
                                                        <asp:ListItem Value="30">mounth</asp:ListItem>
                                                    </cc1:OboutDropDownList>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    Explanation:
                                                </td>
                                                <td>
                                                    <cc1:OboutTextBox runat="server" ID="txtExpCourseTopics" Width="250" TextMode="MultiLine" />
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    View Order:
                                                </td>
                                                <td>
                                                    <cc1:OboutDropDownList runat="server" ID="txtViewOrderCourseTopics" CssClass="ob_gEC"
                                                        Width="70" Height="100">
                                                        <asp:ListItem Value="0">0</asp:ListItem>
                                                        <asp:ListItem Value="1">1</asp:ListItem>
                                                        <asp:ListItem Value="2">2</asp:ListItem>
                                                        <asp:ListItem Value="3">3</asp:ListItem>
                                                        <asp:ListItem Value="4">4</asp:ListItem>
                                                        <asp:ListItem Value="5">5</asp:ListItem>
                                                        <asp:ListItem Value="6">6</asp:ListItem>
                                                        <asp:ListItem Value="7">7</asp:ListItem>
                                                        <asp:ListItem Value="8">8</asp:ListItem>
                                                        <asp:ListItem Value="9">9</asp:ListItem>
                                                        <asp:ListItem Value="10">10</asp:ListItem>
                                                    </cc1:OboutDropDownList>
                                                </td>
                                            </tr>
                                        </table>
                                    </fieldset>
                                    <asp:Label runat="server" ID="txtIdCourseTopics" Width="6" Enabled="false" />
                                </td>
                            </tr>
                        </table>
                    </Template>
                </cc1:GridTemplate>
            </Templates>
        </cc1:DetailGrid>
    </DetailGrids>--%>
    <Columns>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="id" HeaderText="Id" Width="200px"
            Visible="false">
            <TemplateSettings RowEditTemplateControlId="txtId" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="name" HeaderText="Course"
            Width="50%" Wrap="true">
            <TemplateSettings RowEditTemplateControlId="txtName" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="GoalName" HeaderText="Goal Name"
            Width="50%" Wrap="true">
            <TemplateSettings RowEditTemplateControlId="ddlAbstactGoals" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="code" HeaderText="Code" Width="100px"
            Visible="true">
            <TemplateSettings RowEditTemplateControlId="txtCode" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="UserName" HeaderText="Owner"
            Width="100px">
            <%--<TemplateSettings RowEditTemplateControlId="ddlUsers" RowEditTemplateControlPropertyName="value" />--%>
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="durationType" HeaderText="Duration Type"
            Width="200px" Visible="false">
            <TemplateSettings RowEditTemplateControlId="ddlDurationType" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="duration" HeaderText="Duration"
            Width="100px" Visible="false">
            <TemplateSettings RowEditTemplateControlId="txtDuration" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="exp" HeaderText="Explanation"
            Width="150px" Visible="false">
            <TemplateSettings RowEditTemplateControlId="txtExp" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="credit" HeaderText="Credit"
            Width="100px" Visible="false">
            <TemplateSettings RowEditTemplateControlId="txtCredit" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="state" HeaderText="State"
            Width="90px">
            <TemplateSettings FilterTemplateId="stateFilterTemplate" TemplateId="TemplateIsApproved"
                RowEditTemplateControlId="txtState" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ID="Column1" AllowEdit="true" AllowDelete="true" HeaderText="Edit / Delete"
            Width="120" runat="server" />
    </Columns>
    <TemplateSettings RowEditTemplateId="tplRowEdit" GroupHeaderTemplateId="GroupTemplate" />
    <Templates>
        <cc1:GridTemplate runat="server" ID="stateFilterTemplate" ControlID="ddlState" ControlPropertyName="value">
            <Template>
                <cc1:OboutDropDownList runat="server" ID="ddlState" CssClass="ob_gEC" Width="75"
                    Height="70" AppendDataBoundItems="true" MenuWidth="100">
                    <asp:ListItem Text="Select..." Selected="True" Value="0"></asp:ListItem>
                    <asp:ListItem Text="Waiting" Value="1"></asp:ListItem>
                    <asp:ListItem Text="Approved" Value="2"></asp:ListItem>
                    <asp:ListItem Text="Rejected" Value="3"></asp:ListItem>
                </cc1:OboutDropDownList>
            </Template>
        </cc1:GridTemplate>
        <cc1:GridTemplate runat="server" ID="GroupTemplate">
            <Template>
                <b>
                    <%# Container.Column.HeaderText %>
                    : </b><i>
                        <%# (Container.Value == "1" ? "Waiting" : (Container.Value == "2" ? "Approved" : "Rejected"))%></i>
                (<%# Container.Group.PageRecordsCount %>
                <%# Container.Group.PageRecordsCount > 1 ? "records" : "record" %>)
            </Template>
        </cc1:GridTemplate>
        <cc1:GridTemplate runat="server" ID="TemplateIsApproved" UseQuotes="true">
            <Template>
                <%# (Container.Value == "1" ? "Waiting" : (Container.Value == "2" ? "Approved" : "Rejected"))%>
            </Template>
        </cc1:GridTemplate>
        <cc1:GridTemplate runat="server" ID="tplRowEdit">
            <Template>
                <table class="rowEditTable">
                    <tr>
                        <td valign="top">
                            <fieldset style="width: 380px; height: 140px;">
                                <legend>Course Information</legend>
                                <table>
                                    <tr>
                                        <td>
                                            Goal Name:
                                        </td>
                                        <td>
                                            <cc1:OboutDropDownList runat="server" ID="ddlAbstactGoals" DataSourceID="SqlDataSourceAbstactGoals"
                                                DataValueField="id" DataTextField="name" CssClass="ob_gEC" Width="250" Height="50"
                                                AppendDataBoundItems="true">
                                                <asp:ListItem Text="Select..." Selected="True"></asp:ListItem>
                                            </cc1:OboutDropDownList>
                                        </td>
                                    </tr>
                                    <%-- <tr>
                                        <td>
                                            User Name:
                                        </td>
                                        <td>
                                            <cc1:OboutDropDownList runat="server" ID="ddlUsers" DataSourceID="SqlDataSourceUsers"
                                                DataValueField="userId" DataTextField="UserName" CssClass="ob_gEC" Width="250"
                                                Height="50" AppendDataBoundItems="true">
                                                <asp:ListItem Text="Select..." Selected="True"></asp:ListItem>
                                            </cc1:OboutDropDownList>
                                        </td>
                                    </tr>--%>
                                    <tr>
                                        <td>
                                            Name:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtName" Width="250" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Code:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtCode" Width="250" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Duration:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtDuration" Width="50" />
                                            <cc1:OboutDropDownList runat="server" ID="ddlDurationType" CssClass="ob_gEC" Width="100"
                                                Height="52">
                                                <asp:ListItem Value="1">day</asp:ListItem>
                                                <asp:ListItem Value="7">week</asp:ListItem>
                                                <asp:ListItem Value="30">mounth</asp:ListItem>
                                            </cc1:OboutDropDownList>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Explanation:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtExp" Width="250" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Credit:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtCredit" Width="250" />
                                        </td>
                                    </tr>
                                </table>
                            </fieldset>
                            <asp:Label runat="server" ID="txtId" Width="0" Enabled="false" />
                            <asp:Label runat="server" ID="txtState" Enabled="false" Width="0" />
                        </td>
                    </tr>
                </table>
            </Template>
        </cc1:GridTemplate>
    </Templates>
</cc1:Grid>
<asp:Label ID="Label1" runat="server" ForeColor="Red"></asp:Label>
<asp:SqlDataSource ID="SqlDataSourceCourses" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
    DeleteCommand="DELETE FROM AcmeSoft.tblCourses WHERE (id = @id)" SelectCommand="SELECT AcmeSoft.tblCourses.id, AcmeSoft.tblCourses.goalId, AcmeSoft.tblCourses.userId, AcmeSoft.tblCourses.name, AcmeSoft.tblCourses.code, AcmeSoft.tblCourses.durationType, AcmeSoft.tblCourses.duration, AcmeSoft.tblCourses.exp, AcmeSoft.tblCourses.credit, AcmeSoft.tblCourses.state, AcmeSoft.tblAbstractGoals.name AS GoalName, aspnet_Users.UserName FROM AcmeSoft.tblCourses INNER JOIN AcmeSoft.tblAbstractGoals ON AcmeSoft.tblCourses.goalId = AcmeSoft.tblAbstractGoals.id INNER JOIN aspnet_Users ON AcmeSoft.tblCourses.userId = aspnet_Users.UserId ORDER BY AcmeSoft.tblCourses.name"
    InsertCommand="INSERT INTO AcmeSoft.tblCourses(goalId, userId, name, code, durationType, duration, exp, credit) VALUES (@GoalName, @UserName, @name, @code, @durationType, @duration, @exp, @credit)"
    UpdateCommand="UPDATE AcmeSoft.tblCourses SET goalId = @GoalName, userId = @UserName, name = @name, durationType = @durationType, code = @code, duration = @duration, exp = @exp, credit = @credit, state = '1' WHERE id = @id">
    <DeleteParameters>
        <asp:Parameter Name="id" />
    </DeleteParameters>
    <UpdateParameters>
        <asp:Parameter Name="GoalName" />
        <%--<asp:Parameter Name="UserName" />--%>
        <asp:SessionParameter Name="UserName" SessionField="USER_ID" />
        <asp:Parameter Name="name" />
        <asp:Parameter Name="durationType" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="duration" />
        <asp:Parameter Name="exp" />
        <asp:Parameter Name="credit" />
        <asp:Parameter Name="id" />
    </UpdateParameters>
    <InsertParameters>
        <%--<asp:Parameter Name="GoalName" />
        <asp:Parameter Name="UserName" />
        <asp:Parameter Name="name" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="durationType" />
        <asp:Parameter Name="duration" />
        <asp:Parameter Name="exp" />
        <asp:Parameter Name="credit" />--%>
    </InsertParameters>
</asp:SqlDataSource>
<asp:SqlDataSource ID="SqlDataSourceUsers" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
    SelectCommand="SELECT UserId, UserName FROM aspnet_Users"></asp:SqlDataSource>
<asp:SqlDataSource ID="SqlDataSourceAbstactGoals" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
    SelectCommand="SELECT id, name, exp FROM AcmeSoft.tblAbstractGoals"></asp:SqlDataSource>
<asp:SqlDataSource ID="SqlDataSourceCourseTopics" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
    DeleteCommand="DELETE FROM AcmeSoft.tblCourseTopics WHERE (id = @id)" SelectCommand="SELECT AcmeSoft.tblCourseTopics.id, AcmeSoft.tblCourseTopics.courseId, AcmeSoft.tblCourseTopics.userId, AcmeSoft.tblCourseTopics.objectiveId, AcmeSoft.tblCourseTopics.name, AcmeSoft.tblCourseTopics.code, AcmeSoft.tblCourseTopics.exp, AcmeSoft.tblCourseTopics.duration, AcmeSoft.tblCourseTopics.durationType, AcmeSoft.tblCourseTopics.viewOrder, AcmeSoft.tblCourseObjectives.name AS ObjName, AcmeSoft.tblCourses.name AS CourseName, aspnet_Users.UserName FROM AcmeSoft.tblCourseTopics INNER JOIN aspnet_Users ON AcmeSoft.tblCourseTopics.userId = aspnet_Users.UserId INNER JOIN AcmeSoft.tblCourseObjectives ON AcmeSoft.tblCourseTopics.objectiveId = AcmeSoft.tblCourseObjectives.id INNER JOIN AcmeSoft.tblCourses ON AcmeSoft.tblCourseTopics.courseId = AcmeSoft.tblCourses.id WHERE (AcmeSoft.tblCourseTopics.courseId = @id)"
    InsertCommand="INSERT INTO AcmeSoft.tblCourseTopics(courseId, objectiveId, userId, name, code, durationType, duration, exp, viewOrder) VALUES (@CourseName, @ObjName @UserName, @name, @code, @durationType, @duration, @exp, @viewOrder)"
    UpdateCommand="UPDATE AcmeSoft.tblCourseTopics SET courseId = @CourseName, objectiveId = @ObjName, userId = @UserName, name = @name, durationType = @durationType, code = @code, duration = @duration, exp = @exp, viewOrder = @viewOrder WHERE id = @id">
    <SelectParameters>
        <asp:Parameter Name="id" />
    </SelectParameters>
    <DeleteParameters>
        <asp:Parameter Name="id" />
    </DeleteParameters>
    <UpdateParameters>
        <asp:Parameter Name="CourseName" />
        <asp:Parameter Name="ObjName" />
        <asp:Parameter Name="UserName" />
        <asp:Parameter Name="name" />
        <asp:Parameter Name="durationType" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="duration" />
        <asp:Parameter Name="exp" />
        <asp:Parameter Name="viewOrder" />
        <asp:Parameter Name="id" />
    </UpdateParameters>
    <InsertParameters>
        <asp:Parameter Name="CourseName" />
        <asp:Parameter Name="ObjName" />
        <asp:Parameter Name="UserName" />
        <asp:Parameter Name="name" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="durationType" />
        <asp:Parameter Name="duration" />
        <asp:Parameter Name="exp" />
        <asp:Parameter Name="viewOrder" />
    </InsertParameters>
</asp:SqlDataSource>
