﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.IO;
using System.Text.RegularExpressions;

namespace acmesoft.web.ascx
{
    public partial class MasterDetail : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            HttpFileCollection files = Page.Request.Files;
            string filesRoot = "/Organizations/CourseMaterials/";
            string filePath = "";
            string fileName = "";

            for (int i = 0; i < files.Count; i++)
            {
                HttpPostedFile file = files[i];
                if (file.FileName.Length > 0)
                {
                    Regex reg = new Regex(@"((?:[^\\]*\\)*)(\S+)", RegexOptions.Compiled);
                    fileName = DateTime.Now.Ticks.ToString() + "_" + reg.Replace(file.FileName, "$2");
                    filePath = filesRoot + fileName;

                    file.SaveAs(Server.MapPath(filePath));
                    break;
                }
            }
        }
        protected void gridAbstractGoals_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSourceAbstractGoal.ConnectionString);
            myConn.Open();

            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblAbstractGoals(organizationId, userId, name, code, exp, prerequisites) VALUES (@organizationId, @userId, @name, @code, @exp, @prerequisites)", myConn);

            myComm.Parameters.Add("@organizationId", SqlDbType.VarChar).Value = e.Record["OrgName"];
            myComm.Parameters.Add("@userId", SqlDbType.VarChar).Value = e.Record["UserName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@prerequisites", SqlDbType.VarChar).Value = e.Record["prerequisites"];

            myComm.ExecuteNonQuery();

            DataSet ds = new DataSet();
            SqlDataAdapter adp = new SqlDataAdapter(("SELECT id FROM AcmeSoft.tblAbstractGoals WHERE name = '" + e.Record["name"] + "'"), myConn);
            adp.Fill(ds);
            Directory.CreateDirectory(Server.MapPath("/Organizations/") + e.Record["OrgName"] + "/" + ds.Tables[0].Rows[0].ItemArray[0].ToString());

            myConn.Close();
        }

        protected void gridAbstractGoals_UpdateCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSourceAbstractGoal.ConnectionString);
            DataSet ds = new DataSet();

            myConn.Open();
            SqlDataAdapter adp = new SqlDataAdapter(("SELECT organizationId FROM AcmeSoft.tblAbstractGoals WHERE id = '" + e.Record["id"] + "'"), myConn);
            adp.Fill(ds);

            SqlCommand myComm = new SqlCommand("UPDATE AcmeSoft.tblAbstractGoals SET organizationId = @OrgName, userId = @UserName, name = @name, code = @code, exp = @exp, prerequisites = @prerequisites WHERE id = @id", myConn);
            myComm.Parameters.Add("@OrgName", SqlDbType.VarChar).Value = e.Record["OrgName"];
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = e.Record["UserName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@prerequisites", SqlDbType.VarChar).Value = e.Record["prerequisites"];
            myComm.Parameters.Add("@id", SqlDbType.VarChar).Value = e.Record["id"];

            myComm.ExecuteNonQuery();
            myConn.Close();
            Directory.Move(Server.MapPath("/Organizations" + "\\" + ds.Tables[0].Rows[0].ItemArray[0].ToString() + "\\" + e.Record["id"].ToString()), Server.MapPath("/Organizations" + "\\" + e.Record["OrgName"] + "\\" + e.Record["id"].ToString()));
        }
        protected void gridCourses_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {

            SqlConnection myConn = new SqlConnection(SqlDataSourceCourses.ConnectionString);
            myConn.Open();

            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblCourses(goalId, userId, name, code, durationType, duration, exp, credit)"
                + " VALUES (@GoalName, @UserName, @name, @code, @durationType, @duration, @exp, @credit)", myConn);

            myComm.Parameters.Add("@GoalName", SqlDbType.VarChar).Value = e.Record["GoalName"];
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = e.Record["UserName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@durationType", SqlDbType.VarChar).Value = e.Record["durationType"];
            myComm.Parameters.Add("@duration", SqlDbType.VarChar).Value = e.Record["duration"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@credit", SqlDbType.VarChar).Value = e.Record["credit"];

            myComm.ExecuteNonQuery();
            myConn.Close();
        }
        protected void gridCourseTopics_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {

            SqlConnection myConn = new SqlConnection(SqlDataSourceCourseTopics.ConnectionString);
            myConn.Open();

            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblCourseTopics(courseId, objectiveId, userId, name, code, durationType, duration, exp, viewOrder)"
                + " VALUES (@CourseName, @ObjName, @UserName, @name, @code, @durationType, @duration, @exp, @viewOrder)", myConn);

            myComm.Parameters.Add("@CourseName", SqlDbType.VarChar).Value = e.Record["CourseName"];
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = e.Record["UserName"];
            myComm.Parameters.Add("@ObjName", SqlDbType.VarChar).Value = e.Record["ObjName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@durationType", SqlDbType.VarChar).Value = e.Record["durationType"];
            myComm.Parameters.Add("@duration", SqlDbType.VarChar).Value = e.Record["duration"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@viewOrder", SqlDbType.VarChar).Value = e.Record["viewOrder"];

            myComm.ExecuteNonQuery();
            myConn.Close();
        }
        protected void gridCourseTopicMaterials_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {

            SqlConnection myConn = new SqlConnection(SqlDataSourceCourseTopicMaterials.ConnectionString);
            myConn.Open();

            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblCourseTopicMaterials(topicId, userId, name, code, exp, filePath, viewOrder)"
                + " VALUES (@TopicName, @UserName, @name, @code, @exp, @filePath, @viewOrder)", myConn);

            myComm.Parameters.Add("@TopicName", SqlDbType.VarChar).Value = e.Record["TopicName"];
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = e.Record["UserName"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];
            myComm.Parameters.Add("@filePath", SqlDbType.VarChar).Value = e.Record["filePath"];
            myComm.Parameters.Add("@exp", SqlDbType.VarChar).Value = e.Record["exp"];
            myComm.Parameters.Add("@viewOrder", SqlDbType.VarChar).Value = e.Record["viewOrder"];

            myComm.ExecuteNonQuery();
            myConn.Close();
        }
    }
}