﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.IO;
using System.Collections;

namespace acmesoft.web.ascx
{
    public partial class Organizations : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Hashtable SmartPlanUser = (Hashtable)Session.Contents["SMART_PLAN_USER"];
            Hashtable RoleStages = (Hashtable)Session.Contents["ROLE_STAGES"];
            string roleId = "";

            if (Session.Contents["ACTIVE_ORGANIZATION_ID"] != null)
                roleId = SmartPlanUser[Session.Contents["ACTIVE_ORGANIZATION_ID"].ToString()].ToString();
            else
                roleId = SmartPlanUser[Session.Contents["DEFAULT_ORGANIZATION_ID"].ToString()].ToString();
            int roleStage = int.Parse(RoleStages[roleId].ToString());

            if (roleStage == 0) //BlockedUsers
            {
                grid1.Visible = false;
                Label1.Text = "Sorry, you are blocked by administrators.";
            }
            else if (roleStage < 4) //ReadOnly
            {
                grid1.Columns[4].AllowDelete = false;
                grid1.Columns[4].AllowEdit = false;
                grid1.AllowAddingRecords = false;
            }
            else if (roleStage == 4) //IUser
            {
                grid1.Columns[4].AllowDelete = false;
                grid1.Columns[4].AllowEdit = false;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage == 5) //UpdateUsers
            {
                grid1.Columns[4].AllowDelete = false;
                grid1.Columns[4].AllowEdit = true;
                grid1.AllowAddingRecords = false;
            }
            else if (roleStage == 7 || roleStage == 6) //ModifyUsers & InsertUsers
            {
                grid1.Columns[4].AllowDelete = false;
                grid1.Columns[4].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage == 8) //Administrators
            {
                grid1.Columns[4].AllowDelete = true;
                grid1.Columns[4].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }
            else if (roleStage < 8) //++Administrator
            {
                grid1.Columns[4].AllowDelete = true;
                grid1.Columns[4].AllowEdit = true;
                grid1.AllowAddingRecords = true;
            }
        }

        protected void grid1_InsertCommand(object sender, Obout.Grid.GridRecordEventArgs e)
        {
            SqlConnection myConn = new SqlConnection(SqlDataSource1.ConnectionString);
            myConn.Open();

            SqlCommand myComm = new SqlCommand("INSERT INTO AcmeSoft.tblOrganizations(serverId, name, code) VALUES (@serverId, @name, @code)", myConn);

            myComm.Parameters.Add("@serverId", SqlDbType.VarChar).Value = e.Record["serverId"];
            myComm.Parameters.Add("@name", SqlDbType.VarChar).Value = e.Record["name"];
            myComm.Parameters.Add("@code", SqlDbType.VarChar).Value = e.Record["code"];

            myComm.ExecuteNonQuery();

            DataSet ds = new DataSet();
            SqlDataAdapter adp = new SqlDataAdapter(("SELECT id FROM AcmeSoft.tblOrganizations WHERE name = '" + e.Record["name"] + "'"), myConn);
            adp.Fill(ds);
            Directory.CreateDirectory(Server.MapPath("/Organizations/") + ds.Tables[0].Rows[0].ItemArray[0].ToString());
            //Directory.CreateDirectory(Server.MapPath("/Organizations/") + e.Record["name"].ToString());
            
            myConn.Close();
        }
    }
}