﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;
using acmesoft.web.ascx;

namespace acmesoft.web.ascx
{
    public partial class RankingCharts : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            PieChart1.ChartTitle = "PieChart";
            PieChart1.ImageAlt = "PieChart";
            PieChart1.ImageWidth = 500;
            PieChart1.ImageHeight = 375;

            BarChart1.ChartTitle = "BarChart";
            BarChart1.ImageAlt = "BarChart";
            BarChart1.ImageWidth = 500;
            BarChart1.ImageHeight = 375;

            Random rand = new Random();

            DataSet ds = new DataSet();
            if (ddlCourses.SelectedIndex == 0)
            {
                BarChart1.Visible = false;
                PieChart1.Visible = false;
            }
            else if (ddlCourses.SelectedIndex > 0)
            {
                SqlConnection myConn = new SqlConnection("Data Source=.\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\ASPNETDB.MDF;Integrated Security=True;User Instance=True");
                myConn.Open();
                SqlCommand myComm = new SqlCommand("SELECT AcmeSoft.tblCourseTopics.id, AcmeSoft.tblCourseTopics.name, AcmeSoft.tblCourseTopics.viewOrder, AcmeSoft.tblCourses.name AS courseName, AcmeSoft.tblCourses.id AS courseId FROM AcmeSoft.tblCourseTopics INNER JOIN AcmeSoft.tblCourses ON AcmeSoft.tblCourseTopics.courseId = AcmeSoft.tblCourses.id WHERE (AcmeSoft.tblCourses.id = @courseId)", myConn);
                myComm.Parameters.Add("@courseId", SqlDbType.VarChar).Value = ddlCourses.SelectedValue;
                SqlDataAdapter adp = new SqlDataAdapter(myComm);
                adp.Fill(ds); // id - name - vieworder - coursename - courseid
                myConn.Close();

                double total = 0;

                for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                {
                    total += Double.Parse(ds.Tables[0].Rows[i].ItemArray[2].ToString());
                }

                int R = rand.Next(0, 255);
                int G = rand.Next(0, 255);
                int B = rand.Next(0, 255);
                double percent = 0;
                string itemName;

                for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                {
                    R = rand.Next(0, 255);
                    G = rand.Next(0, 255);
                    B = rand.Next(0, 255);
                    percent = Double.Parse(ds.Tables[0].Rows[i].ItemArray[2].ToString()) * 100 / total;
                    Color color = Color.FromArgb(R, G, B);
                    itemName = ds.Tables[0].Rows[i].ItemArray[1].ToString();
                    PieChart.PieChartElement myPie = new PieChart.PieChartElement(itemName + ": ", percent, color);
                    BarChart.BarChartElement myBar = new BarChart.BarChartElement(itemName + ": ", (float)percent, color);

                    PieChart1.addPieChartElement(myPie);
                    BarChart1.addBarChartElement(myBar);
                }

                PieChart1.generateChartImage();
                BarChart1.generateChartImage();
                BarChart1.Visible = true;
                PieChart1.Visible = true;
            }
        }
    }
}