﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Roles.ascx.cs" Inherits="acmesoft.web.ascx.Roles" %>

<%@ Register Assembly="obout_Grid_NET" Namespace="Obout.Grid" TagPrefix="cc1" %>
<%@ Register TagPrefix="cc1" Namespace="Obout.Interface" Assembly="obout_Interface" %>

<script language="javascript" type="text/javascript">
    function OnBeforeDelete(record) {
        if (confirm("Are you sure you want to delete the Role with the name [" + record.name + "]?") == false) {
            return false;
        }
        return true;
    }
</script>


<cc1:Grid ID="grid1" runat="server" AutoGenerateColumns="False" FolderStyle="~/elements/style/premiere_blue"
    RowEditTemplateId="tplRowEdit" DataSourceID="SqlDataSource1" 
    oninsertcommand="grid1_InsertCommand" Width="100%">
    <ClientSideEvents OnBeforeClientDelete="OnBeforeDelete" />
    <Columns>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="RoleId" HeaderText="RoleId" Width="0"
            Visible="false">
            <TemplateSettings RowEditTemplateControlId="txtRoleId" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="RoleName" HeaderText="Role Name" Width="200px">
            <TemplateSettings RowEditTemplateControlId="txtRoleName" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="Description" HeaderText="Description" Width="100%" Wrap="true">
            <TemplateSettings RowEditTemplateControlId="txtDescription" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="Stage" HeaderText="Level" Width="100px">
            <TemplateSettings RowEditTemplateControlId="txtStage" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="code" HeaderText="Code" Width="150px">
            <TemplateSettings RowEditTemplateControlId="txtCode" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ConvertEmptyStringToNull="False" DataField="ApplicationId" HeaderText="Application Name"
            Width="200px" Visible="false">
            <TemplateSettings RowEditTemplateControlId="ddlApplications" RowEditTemplateControlPropertyName="value" />
        </cc1:Column>
        <cc1:Column ID="Column1" AllowEdit="true" AllowDelete="true" HeaderText="Edit / Delete"
            Width="120" runat="server" />
    </Columns>
    <TemplateSettings RowEditTemplateId="tplRowEdit" />
    <Templates>
        <cc1:GridTemplate runat="server" ID="tplRowEdit">
            <Template>
                <table class="rowEditTable">
                    <tr>
                        <td valign="top">
                            <fieldset style="width: 380px; height: 150px;">
                                <legend>Role Information</legend>
                                <table>
                                    <tr>
                                        <td>
                                            Name:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtRoleName" Width="250" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Description:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtDescription" Width="250" TextMode="MultiLine" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Level:
                                        </td>
                                        <td>
                                            <cc1:OboutDropDownList runat="server" ID="txtStage" CssClass="ob_gEC"
                                                Width="70" Height="100">
                                                <asp:ListItem Value="0">0</asp:ListItem>
                                                <asp:ListItem Value="1">1</asp:ListItem>
                                                <asp:ListItem Value="2">2</asp:ListItem>
                                                <asp:ListItem Value="3">3</asp:ListItem>
                                                <asp:ListItem Value="4">4</asp:ListItem>
                                                <asp:ListItem Value="5">5</asp:ListItem>
                                                <asp:ListItem Value="6">6</asp:ListItem>
                                                <asp:ListItem Value="7">7</asp:ListItem>
                                                <asp:ListItem Value="8">8</asp:ListItem>
                                                <asp:ListItem Value="9">9</asp:ListItem>
                                                <asp:ListItem Value="10">10</asp:ListItem>
                                            </cc1:OboutDropDownList>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Code:
                                        </td>
                                        <td>
                                            <cc1:OboutTextBox runat="server" ID="txtCode" Width="250" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            Application Name:
                                        </td>
                                        <td>
                                            <cc1:OboutDropDownList runat="server" ID="ddlApplications" DataSourceID="SqlDataSourceApplications" DataValueField="ApplicationId"
                                                DataTextField="ApplicationName" CssClass="ob_gEC" Width="250" Height="50" />
                                        </td>
                                    </tr>
                                </table>
                            </fieldset>
                            <asp:Label runat="server" ID="txtRoleId" Width="6" Enabled="false" />
                        </td>
                    </tr>
                </table>
            </Template>
        </cc1:GridTemplate>
    </Templates>
</cc1:Grid>
<asp:Label ID="Label1" runat="server" ForeColor="Red"></asp:Label>

<asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
    DeleteCommand="DELETE FROM aspnet_Roles WHERE (RoleId = @RoleId)" 
    SelectCommand="SELECT ApplicationId, RoleId, RoleName, Description, Stage, code FROM aspnet_Roles"
    InsertCommand="INSERT INTO aspnet_Roles(RoleName, Description, Stage, code, ApplicationId) VALUES (@RoleName, @Description, @Stage, @code, @ApplicationId)"
    
    UpdateCommand="UPDATE aspnet_Roles SET ApplicationId = @ApplicationId, RoleName = @RoleName, Description = @Description, Stage = @Stage, code = @code WHERE RoleId = @RoleId">
    <DeleteParameters>
        <asp:Parameter Name="RoleId" />
    </DeleteParameters>
    <UpdateParameters>
        <asp:Parameter Name="ApplicationId" />
        <asp:Parameter Name="RoleName" />
        <asp:Parameter Name="Description" />
        <asp:Parameter Name="Stage" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="RoleId" />
    </UpdateParameters>
    <InsertParameters>
        <asp:Parameter Name="RoleName" />
        <asp:Parameter Name="Description" />
        <asp:Parameter Name="Stage" />
        <asp:Parameter Name="code" />
        <asp:Parameter Name="ApplicationId" />
    </InsertParameters>
</asp:SqlDataSource>
<asp:SqlDataSource ID="SqlDataSourceApplications" runat="server" 
    ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>" 
    SelectCommand="SELECT ApplicationName, ApplicationId FROM aspnet_Applications">
</asp:SqlDataSource>

