﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using acmesoft.web.linq;
using System.Drawing;
using System.Data.SqlClient;
using System.Data;
using System.Collections;

namespace acmesoft.web
{
    public class Application
    {
        public Hashtable SmartPlanUser = new Hashtable();
        public Hashtable RoleStages = new Hashtable();
        public Hashtable OrganizationNames = new Hashtable();
        public Hashtable Applications = new Hashtable();
        public Hashtable ApplicationPath = new Hashtable();
        public string defaultOrganization = "";
        //public String[] userOrganizations = { };
        public DataSet userOrganizationRoles = new DataSet();
        public DataSet dsApplications = new DataSet();
        public string GetApplicationPath(string userId, string roleId, string organizationId)
        {
            string appPath = "";
            SmartPlanLinqDataContext SmartPlanDB = new SmartPlanLinqDataContext();

            var application = from ap in SmartPlanDB.aspnet_Applications
                              where ap.LoweredApplicationName == userId
                              select new {ap.ApplicationName};

            var users = from p in SmartPlanDB.aspnet_UsersInRoles
                        orderby p.aspnet_Role.Stage ascending
                        where p.aspnet_Role.Stage >= 5
                        select new { p.RoleId, p.UserId, p.createDate, p.aspnet_User.UserName, p.aspnet_Role.Stage };
            
            foreach (var app in application)
                appPath = app.ApplicationName.ToString();
            return appPath;
        }
        public void GetApplications(string userId, string roleId, string organizationId)
        {
            string ApplicationId, ApplicationPath;
            SqlConnection myConn = new SqlConnection("Data Source=.\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\ASPNETDB.MDF;Integrated Security=True;User Instance=True");
            myConn.Open();
            SqlCommand myComm = new SqlCommand("SELECT ApplicationId, ApplicationName, name, isDirected, redirectAppId, filePath, viewOrder FROM aspnet_Applications ORDER BY viewOrder", myConn);
            //myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = userName;
            SqlDataAdapter adp = new SqlDataAdapter(myComm);
            adp.Fill(dsApplications);
            myConn.Close();

            for (int i = 0; i < dsApplications.Tables[0].Rows.Count; i++)
            {
                ApplicationId = dsApplications.Tables[0].Rows[i].ItemArray[0].ToString();
                ApplicationPath = dsApplications.Tables[0].Rows[i].ItemArray[5].ToString();
                Applications.Add(ApplicationId, ApplicationPath);
            }
        }
        public string GetUserId(string userName)
        {
            string userId = "";
            DataSet ds = new DataSet();
            SqlConnection myConn = new SqlConnection("Data Source=.\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\ASPNETDB.MDF;Integrated Security=True;User Instance=True");
            myConn.Open();
            SqlCommand myComm = new SqlCommand("SELECT UserId FROM aspnet_Users WHERE (UserName = @UserName)", myConn);
            myComm.Parameters.Add("@UserName", SqlDbType.VarChar).Value = userName;
            SqlDataAdapter adp = new SqlDataAdapter(myComm);
            adp.Fill(ds);
            myConn.Close();
            userId = ds.Tables[0].Rows[0].ItemArray[0].ToString();
            return userId;
        }
        public void GetUserRoleInOrganization(string userId)
        {
            string RoleId, OrgId, OrgName, RoleStage;
            SqlConnection myConn = new SqlConnection("Data Source=.\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\ASPNETDB.MDF;Integrated Security=True;User Instance=True");
            myConn.Open();
            SqlCommand myComm = new SqlCommand("SELECT AcmeSoft.tblOrganizations.name, AcmeSoft.UsersInRolesInOrganizations.OrganizationId, AcmeSoft.UsersInRolesInOrganizations.RoleId, aspnet_Roles.Stage"
                + " FROM AcmeSoft.UsersInRolesInOrganizations" 
                + " INNER JOIN AcmeSoft.tblOrganizations ON AcmeSoft.UsersInRolesInOrganizations.OrganizationId = AcmeSoft.tblOrganizations.id"
                + " INNER JOIN aspnet_Roles ON AcmeSoft.UsersInRolesInOrganizations.RoleId = aspnet_Roles.RoleId"
                + " WHERE (UserId = @UserId) ORDER BY AcmeSoft.tblOrganizations.name", myConn);
            myComm.Parameters.Add("@userId", SqlDbType.VarChar).Value = userId;
            SqlDataAdapter adp = new SqlDataAdapter(myComm);
            adp.Fill(userOrganizationRoles);
            myConn.Close();
            for (int i = 0; i < userOrganizationRoles.Tables[0].Rows.Count; i++)
            {
                OrgName = userOrganizationRoles.Tables[0].Rows[i].ItemArray[0].ToString();
                OrgId = userOrganizationRoles.Tables[0].Rows[i].ItemArray[1].ToString();
                RoleId = userOrganizationRoles.Tables[0].Rows[i].ItemArray[2].ToString();
                RoleStage = userOrganizationRoles.Tables[0].Rows[i].ItemArray[3].ToString();
                OrganizationNames.Add(OrgId, OrgName);
                SmartPlanUser.Add(OrgId, RoleId);
                RoleStages.Add(RoleId, RoleStage);
            }

            defaultOrganization = userOrganizationRoles.Tables[0].Rows[0].ItemArray[1].ToString();
            //return RoleId;
        }
    }
}
